<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\ApiController;
use App\Http\Controllers\Controller;
use App\Models\Airline;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class AirlineApiController extends ApiController
{
    const array CONDOR_LOGOS = ['BEACH', 'ISLAND', 'PASSION', 'SEA', 'SUNSHINE'];

    public function getAirlineLogo(?Airline $airline)
    {
        $logoFile = $airline?->logo ?? 'blank.png';
        $cacheLimit = 60 * 60 * 24;

        if ($airline?->internal_name == 'condor') {
            $logoKey = array_rand(self::CONDOR_LOGOS);
            $logoFile = 'DE_' . self::CONDOR_LOGOS[$logoKey] . '.png';
            $cacheLimit = 1;
        }

        $path = 'images/logos/tail/' . $logoFile;
        if (!Storage::disk('local')->exists($path)) {
            $path = 'images/logos/tail/blank.png';
        }

        $fullPath = Storage::disk('local')->path($path);
        $lastModified = filemtime($fullPath);

        return response()->file($fullPath, [
            'Content-Type'  => 'image/png',
            'Cache-Control' => 'public, max-age='.$cacheLimit, // 24 hours
            'Last-Modified' => gmdate('D, d M Y H:i:s', $lastModified) . ' GMT',
            'ETag'          => md5($path . $lastModified),
        ]);
    }


    public function getLogoByInternalName(string $internalName){
        $airline = Airline::where('internal_name', $internalName)
            ->first();

        return $this->getAirlineLogo($airline);
    }

    public function getLivery(string $airlineInternalName, string $aircraftDesignator){
        $path = "images/liveries/{$airlineInternalName}_{$aircraftDesignator}.png";

        return $this->imageIfExists($path);
    }

    function parseAirlineData(Airline $airline){
        $countryCode = $airline->country->code;

        $result = $airline->toArray();
        unset($result['id']);
        unset($result['logo']);
        unset($result['country_id']);
        unset($result['country']);
        $result['slug'] = $result['internal_name'];
        unset($result['internal_name']);
        $result['country_code'] = $countryCode;
        return $result;
    }

    function getByCode(string $code){
        $lookupColumn = strlen($code) === 3 ? 'icao_code' : 'iata_code';
        $airlines = Airline::where($lookupColumn, strtoupper($code))->get()->map(fn($airline) => $this->parseAirlineData($airline));
        return response()->json($airlines);

    }

    function get(string $internalName){
        $airline = Airline::where('internal_name', $internalName)->first();
        return response()->json($this->parseAirlineData($airline));
    }

}
